<template>
    <div class="modal-mask">
      <div class="modal-wrapper">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">
                {{ selected.venueId ? "Edit venue" : "Create venue" }}
              </h5>
              <button
                type="button"
                class="close"
                data-dismiss="modal"
                aria-label="Close"
              >
                <span aria-hidden="true" @click="$emit('closed')">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <div class="fluid-container">
                <div class="d-flex flex-wrap"></div>
                <form>
                  <div class="form-group">
                    <label for="address">Address</label>
                    <input
                      type="text"
                      class="form-control"
                      id="address"
                      placeholder="Enter the address"
                      v-model="selected.address"
                      required
                    />
                  </div>
                  <div class="form-group">
                    <label for="postalcode">Postalcode</label>
                    <input
                      type="text"
                      class="form-control"
                      id="postcode"
                      placeholder="Postalcode"
                      pattern="\d{4}"
                      v-model="selected.postalCode"
                      required
                    />
                  </div>
                  <div class="form-group">
                    <label for="type">Type</label>
                    <select
                      class="custom-select"
                      required
                      id="type"
                      v-model="selected.type"
                    >
                      <option value="0">Gym</option>
                      <option value="1">Public</option>
                      <option value="2">Home</option>
                    </select>
                  </div>
                  <div class="form-check">
                    <input
                      type="checkbox"
                      class="form-check-input"
                      id="isactive"
                      v-model="selected.isActive"
                    />
                    <label for="isactive">Active</label>
                  </div>
                  <div class="modal-footer">
                    <button
                      type="submit"
                      class="btn btn-primary"
                      @click.prevent="submitForm"
                    >
                      Submit
                    </button>
                    <button class="btn btn-secondary" @click="$emit('closed')">
                      Close
                    </button>
                  </div>
                </form>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
</template>

<script>
import axios from "../../controllers/venue.controller";
// TODO: Have some kind of validation for the fields
export default {
  name: "VenueModal",
  data: function () {
    return {
      active: true,
    };
  },
  props: ["selected"],
  methods: {
    show() {
      this.active = true;
    },
    // Either posts or Puts the venue depending if an existing venue or not
    async updateVenue(venue) {
      if (!venue.venueId) {
        await axios.postVenue(venue);
      } else {
        await axios.putVenue(venue);
      }

      let venues = await axios.getVenues();
      return venues;
    },
    // Submits and returns the new list of venues
    //TODO: maybe not do it here?
    async submitForm() {
      let venues = await this.updateVenue(this.selected);
      this.$emit("closed", venues.data);
    },
  }
};
</script>

<style>
.modal-mask {
  position: fixed;
  z-index: 9998;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background-color: rgba(0, 0, 0, 0.5);
  display: table;
  transition: opacity 0.3s ease;
}

.modal-wrapper {
  display: table-cell;
  vertical-align: middle;
}
</style>